Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joone.engine.extenders
Class GradientExtender

    java.lang.Object
      org.joone.engine.extenders.LearnerExtender
          org.joone.engine.extenders.GradientExtender

    public abstract class GradientExtender

extends LearnerExtender

This abstract class describes the methods needed for a gradient extender, that is, a class that computes / changes the gradient value according to some algorithm.

Author:
  Boris Jansen

Constructor Summary
`GradientExtender()` Creates a new instance of DeltaExtender

Method Summary
`abstract double` | `getGradientBias(double[] currentGradientOuts, int j, double aPreviousGradient)` Computes the gradient value for a bias.
`abstract double` | `getGradientWeight(double[] currentInps, int j, double[] currentPattern, int k, double aPreviousGradient)` Computes the gradient value for a weight.

Methods inherited from class org.joone.engine.extenders.LearnerExtender
`getLearner, isEnabled, postBiasUpdate, postWeightUpdate, preBiasUpdate, preWeightUpdate, setEnabled, setLearner`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### GradientExtender

    public GradientExtender()

  Creates a new instance of DeltaExtender

Method Detail

### getGradientBias

    public abstract double getGradientBias(double[] currentGradientOuts,
                                           int j,
                                           double aPreviousGradient)

  Computes the gradient value for a bias.

  Parameters:
    `currentGradientOuts` - the back propagated gradients.
    `j` - the index of the bias.
    `aPreviousGradient` - a gradient value calculated by a previous gradient extender.

### getGradientWeight

    public abstract double getGradientWeight(double[] currentInps,
                                             int j,
                                             double[] currentPattern,
                                             int k,
                                             double aPreviousGradient)

  Computes the gradient value for a weight.

  Parameters:
    `currentInps` - the forwarded input.
    `j` - the input index of the weight.
    `currentPattern` - the back propagated gradients.
    `k` - the output index of the weight.
    `aPreviousGradient` - a gradients value calculated by a previous gradients extender.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit Feedback to pmarrone@users.sourceforge.net